<?php
/**
 *
 * @package Forum Subscriptions
 * @copyright (c) 2022 devspace
 * @license GNU General Public License, version 2 (GPL-2.0)
 *
 */

namespace devspace\forumsubs\migrations\v_3_3_0;

use phpbb\db\migration\migration;

class install_module extends migration
{
	/**
	 * {@inheritdoc
	 */
	public static function depends_on()
	{
		return ['\devspace\forumsubs\migrations\v_3_3_0\install_cat'];
	}

	/**
	 * {@inheritdoc
	 */
	public function update_data()
	{
		return [
			// Add the ACP module
			['module.add', [
				'acp', 'ACP_USER_UTILS', [
					'module_basename' => '\devspace\forumsubs\acp\acp_forumsubs_module',
					'modes' => ['main'],
				],
			]],

			['module.add', [
				'acp', 'ACP_GROUPS', [
					'module_basename' 	=> '\devspace\forumsubs\acp\groups_forumsubs_module',
					'modes' => ['main'],
				],
			]],

			['module.add', [
				'acp', 'ACP_CAT_USERS', [
					'module_basename' 	=> 'acp_users',
					'module_langname'	=> 'USER_SUBSCRIPTIONS',
					'module_mode' 		=> 'forumsubs',
					'module_display' 	=> false,
					'module_auth' 		=> 'ext_devspace/forumsubs && acl_a_user',
				],
			]],
		];
	}
}
