<?php
/**
 *
 * @package Forum Subscriptions
 * @copyright (c) 2022 devspace
 * @license GNU General Public License, version 2 (GPL-2.0)
 *
 */

namespace devspace\forumsubs\migrations\v_3_3_0;;

use phpbb\db\migration\migration;

class install_sql extends migration
{
	/**
	 * {@inheritdoc
	 */
	public static function depends_on()
	{
		return ['\devspace\forumsubs\migrations\v_3_3_0\install_module'];
	}

	/**
	 * {@inheritdoc
	 */
	public function update_data()
	{
		// Add new permissions
		return [
			['permission.add', ['u_forumsubs_view', true]]
		];
	}

   /**
	 * {@inheritdoc
	 */
	public function update_schema()
	{
		// Add new column to Groups table
		return[
			'add_columns' => [
				$this->table_prefix . 'groups' => [
					'forumsubs_forums' => ['TEXT', null],
				],

				$this->table_prefix . 'forums_watch' => [
					'group_subs' => ['UINT', 0],
				],
			],
		];
	}

	/**
	 * {@inheritdoc
	 */
	public function revert_schema()
	{
		return [
			'drop_columns' => [
				$this->table_prefix . 'groups' => [
					'forumsubs_forums',
				],

				$this->table_prefix . 'forums_watch' => [
					'group_subs',
				],
			],
		];
	}

	/**
	 * {@inheritdoc
	 */
	public function revert_data()
	{
		return [
			['custom', [[$this, 'remove_subscriptions']]],
		];
	}

	/**
	 * {@inheritdoc
	 */
	public function remove_subscriptions()
	{
		$this->db->sql_query('DELETE FROM ' . FORUMS_WATCH_TABLE . " WHERE (group_subs) > 0");
	}
}
